#include <iostream>
#include <fstream>
#include <regex>
using namespace std;

int main( int argc, char *argv[] ) {
   ifstream fin;
   if( argc !=2 ) {
       cout << "файл щаблонов?" << endl;
       return 1;
   } 
   fin.open( argv[ 1 ] ); 
   if( !fin ) {
      cout << "файл шаблонов не найден: " << argv[ 1 ] << endl;      
      return 2;
   }
   int n = 1;
   string cur;
   vector<regex> vr;
   while( true ) {              
      getline( fin, cur );
      if( !fin ) break;                             // EOF
      if( '#' == cur[ 0 ] ) continue;               // комментарий
      if( !cur.length() ) continue;                 // пустая строка
      try { 
         regex rc = regex( cur, regex_constants::ECMAScript );
         vr.push_back( rc );
         cout << "#" << n++ << ":\t" << cur << endl;
      }
      catch( regex_error& e ) {                     // ошибка записи регулярного выражения
         cout << "ошибка:\t" << cur << endl;
      }
   }
   fin.close();
   cout << "-------------------------------------------" << endl;
   cmatch m = cmatch {};
   while( true ) { 
      cout << "> ";
      getline( cin, cur );
      if( cin.eof() ) {
         cout << endl;
         return 0; 
      }
      n = 1;
      for( auto &pt : vr ) { 
         if( regex_match( (char*)cur.c_str(), m, pt ) ) {
            cout << "#" << n << " [" << m.size() << "]: " << m[ 0 ].str() << " => ";
            for( unsigned i = 1; i < m.size(); i++ )
               cout << '<' << m[ i ].str() << ">[" << m.position( i ) << ":" 
                    << m.length( i ) << "]" << ( i != m.size() - 1 ? " | " : "" );
            cout << endl;
         }
         n++;
      }
   }
}

// static constexpr flag_type basic = regex_constants::basic;
// static constexpr flag_type extended = regex_constants::extended;
// static constexpr flag_type awk = regex_constants::awk;
// static constexpr flag_type grep = regex_constants::grep;
